# Symplectic.jl
A Julia Package for Manipulation of Symplectic Matrices.

## Features

* `SymplecticForm` inspired by `UniformScaling` in the built-in `LinearAlgebra` package.
* Functions such as `checkSymplectic`, `getQ`, `getP`, `modes`, `toQPQPBAsis`, `toQQPPBasis` for extracting information from a given symplectic matrix
* Binary functions for direct sum and tensor product.
* Implementation of functions for symplectic Cayley transform (`symplecticCayleyTransform`), pre-IwasawaFacotrization (`preIwasawaFactorization`), and symplectic spectrum (`spectrum`)
* Helper functions for constructing symplectic matrices, e.g., `phaseShifting`, `randomPhaseShifting`, `localSymplecticMatrix`, `randomLocalSymplecticMatrix`, `beamSplitter`, `circulator`, `scatteringMatrix`...
* Implementation of algorithms demonstrated in my research papers, including [AQT](https://journals.aps.org/prl/abstract/10.1103/PhysRevLett.120.020502) (`teleportation`) and [IBS](https://www.nature.com/articles/s41534-022-00581-9) (`intereferenceBasedSequence` and `decoupleSequence`).
* Functions for constructing coupled-mode Hamiltonian.

## Todo
* Documentation and tests are under construction.
* More features will be added later.
